// Main transaction public static void Execute(Application app, Document doc, List <Curve> columnLines, string nameRectColumn, string nameRoundColumn, Level level, bool IsSilent) { // Sort out column boundary // Consider using CurveArray to store the data List <List <Curve> > columnRect = new List <List <Curve> >(); List <Arc> columnRound = new List <Arc>(); List <List <Curve> > columnSpecialShaped = new List <List <Curve> >(); List <int> delIndex = new List <int>(); List <Curve> sortedLines = new List <Curve>(); foreach (Curve columnLine in columnLines) { if (columnLine.GetType().ToString() == "Autodesk.Revit.DB.Arc") { columnRound.Add(columnLine as Arc); delIndex.Add(columnLines.IndexOf(columnLine)); } else { sortedLines.Add(columnLine); } } // this is the temperal method List <List <Curve> > columnGroups = Algorithm.ClusterByIntersect(sortedLines); Debug.Print("Baselines are sorted well"); foreach (List <Curve> columnGroup in columnGroups) { if (Algorithm.GetPtsOfCrvs(columnGroup).Count == columnGroup.Count) { if (Algorithm.IsRectangle(columnGroup)) { columnRect.Add(columnGroup); } else { columnSpecialShaped.Add(columnGroup); } } } Debug.Print("Got rectangle {0}, round {1}, and unique shape {2}", columnRect.Count, columnRound.Count, columnSpecialShaped.Count); // Grab the columntype FilteredElementCollector colColumns = new FilteredElementCollector(doc) .OfClass(typeof(FamilySymbol)); // .OfCategory(BuiltInCategory.OST_Columns); // OST handles the internal family types, maybe? FamilySymbol rectangularColumn = colColumns.FirstElement() as FamilySymbol; // Use default setting to avoid error handling, which is a lack of the line below //FamilySymbol column_demo = columnTypes.Find((FamilySymbol fs) => { return fs.Name == "Column_demo"}); foreach (FamilySymbol columnType in colColumns) { if (columnType.Name == nameRectColumn) { rectangularColumn = columnType as FamilySymbol; break; } } // I don't know if there's a better way to split this... // Column generation if (IsSilent == true) { using (Transaction tx = new Transaction(doc, "Generate rectangular columns")) { FailureHandlingOptions options = tx.GetFailureHandlingOptions(); options.SetFailuresPreprocessor(new Util.FailureSwallower(false, false)); tx.SetFailureHandlingOptions(options); tx.Start(); foreach (List <Curve> baselines in columnRect) { double width = Algorithm.GetSizeOfRectangle(Misc.CrvsToLines(baselines)).Item1; double depth = Algorithm.GetSizeOfRectangle(Misc.CrvsToLines(baselines)).Item2; double angle = Algorithm.GetSizeOfRectangle(Misc.CrvsToLines(baselines)).Item3; FamilySymbol fs = NewRectColumnType(doc, nameRectColumn, width, depth); if (!fs.IsActive) { fs.Activate(); } XYZ columnCenterPt = Algorithm.GetCenterPt(baselines); Line columnCenterAxis = Line.CreateBound(columnCenterPt, columnCenterPt.Add(-XYZ.BasisZ)); // z pointing down to apply a clockwise rotation FamilyInstance fi = doc.Create.NewFamilyInstance(columnCenterPt, fs, level, Autodesk.Revit.DB.Structure.StructuralType.NonStructural); ElementTransformUtils.RotateElement(doc, fi.Id, columnCenterAxis, angle); //Autodesk.Revit.DB.Structure.StructuralType.Column } tx.Commit(); } // To generate the special shaped column you have to do it transaction by transaction // due to the family document reload operation must be out of one. foreach (List <Curve> baselines in columnSpecialShaped) { var boundary = Algorithm.RectifyPolygon(Misc.CrvsToLines(baselines)); FamilySymbol fs = NewSpecialShapedColumnType(app, doc, boundary); if (null == fs) { Debug.Print("Generic Model Family returns no symbol"); continue; } using (Transaction tx = new Transaction(doc, "Generate a special shaped column")) { tx.Start(); if (!fs.IsActive) { fs.Activate(); } XYZ basePt = XYZ.Zero; Line columnBaseAxis = Line.CreateBound(basePt, basePt.Add(-XYZ.BasisZ)); FamilyInstance fi = doc.Create.NewFamilyInstance(basePt, fs, level, Autodesk.Revit.DB.Structure.StructuralType.NonStructural); // DANGEROUS! the coordination transformation should be added here tx.Commit(); } } } else { string caption = "Extrude columns"; string task = "Creating rectangular columns..."; Views.ProgressBar pb1 = new Views.ProgressBar(caption, task, columnRect.Count); foreach (List <Curve> baselines in columnRect) { using (Transaction tx = new Transaction(doc, "Generate a rectangular column")) { tx.Start(); double width = Algorithm.GetSizeOfRectangle(Misc.CrvsToLines(baselines)).Item1; double depth = Algorithm.GetSizeOfRectangle(Misc.CrvsToLines(baselines)).Item2; double angle = Algorithm.GetSizeOfRectangle(Misc.CrvsToLines(baselines)).Item3; FamilySymbol fs = NewRectColumnType(doc, nameRectColumn, width, depth); if (!fs.IsActive) { fs.Activate(); } XYZ columnCenterPt = Algorithm.GetCenterPt(baselines); Line columnCenterAxis = Line.CreateBound(columnCenterPt, columnCenterPt.Add(-XYZ.BasisZ)); // z pointing down to apply a clockwise rotation FamilyInstance fi = doc.Create.NewFamilyInstance(columnCenterPt, fs, level, Autodesk.Revit.DB.Structure.StructuralType.NonStructural); ElementTransformUtils.RotateElement(doc, fi.Id, columnCenterAxis, angle); //Autodesk.Revit.DB.Structure.StructuralType.Column tx.Commit(); } pb1.Increment(); if (pb1.ProcessCancelled) { break; } } pb1.Close(); task = "Creating round columns..."; Views.ProgressBar pb2 = new Views.ProgressBar(caption, task, columnRound.Count); foreach (Arc baseline in columnRound) { using (Transaction tx = new Transaction(doc, "Generate a rounded column")) { tx.Start(); XYZ basePt = baseline.Center; double diameter = Misc.FootToMm(Math.Round(2 * baseline.Radius, 2)); FamilySymbol fs = NewRoundColumnType(doc, nameRoundColumn, diameter); if (!fs.IsActive) { fs.Activate(); } Line columnCenterAxis = Line.CreateBound(basePt, basePt.Add(-XYZ.BasisZ)); // z pointing down to apply a clockwise rotation FamilyInstance fi = doc.Create.NewFamilyInstance(basePt, fs, level, Autodesk.Revit.DB.Structure.StructuralType.NonStructural); tx.Commit(); } pb2.Increment(); if (pb2.ProcessCancelled) { break; } } pb2.Close(); task = "Creating special shaped columns..."; Views.ProgressBar pb3 = new Views.ProgressBar(caption, task, columnSpecialShaped.Count); foreach (List <Curve> baselines in columnSpecialShaped) { var boundary = Algorithm.RectifyPolygon(Misc.CrvsToLines(baselines)); FamilySymbol fs = NewSpecialShapedColumnType(app, doc, boundary); if (null == fs) { Debug.Print("Generic Model Family returns no symbol"); continue; } using (Transaction tx = new Transaction(doc, "Generate a special shaped column")) { tx.Start(); if (!fs.IsActive) { fs.Activate(); } XYZ basePt = XYZ.Zero; Line columnBaseAxis = Line.CreateBound(basePt, basePt.Add(-XYZ.BasisZ)); FamilyInstance fi = doc.Create.NewFamilyInstance(basePt, fs, level, Autodesk.Revit.DB.Structure.StructuralType.NonStructural); // DANGEROUS! the coordination transformation should be added here tx.Commit(); } pb3.Increment(); if (pb3.ProcessCancelled) { break; } } pb3.JobCompleted(); } }
public static void Execute(Document doc, List <Curve> doorCrvs, List <Curve> windowCrvs, List <Curve> wallCrvs, List <Util.TeighaText.CADTextModel> labels, string nameDoor, string nameWindow, Level level, bool IsSilent) { View view = doc.ActiveView; var doorClusters = Algorithm.ClusterByIntersect(doorCrvs); // Sometimes ClusterByIntersect will not return ideal result // because the intersected lines are not detected by the program for no reason // sometimes it goes well // iterate the bounding box generation 2 times may gurantee this but lacking efficiency List <List <Curve> > doorBlocks = new List <List <Curve> > { }; foreach (List <Curve> cluster in doorClusters) { if (null != Algorithm.CreateBoundingBox2D(cluster)) { doorBlocks.Add(Algorithm.CreateBoundingBox2D(cluster)); } } //Debug.Print("{0} clustered door blocks in total", doorBlocks.Count); List <Curve> doorAxes = new List <Curve> { }; foreach (List <Curve> doorBlock in doorBlocks) { List <Curve> doorFrame = new List <Curve> { }; for (int i = 0; i < doorBlock.Count; i++) { int sectCount = 0; List <Curve> fenses = new List <Curve>(); foreach (Curve line in wallCrvs) { Curve testCrv = doorBlock[i].Clone(); SetComparisonResult result = RegionDetect.ExtendCrv(testCrv, 0.01).Intersect(line, out IntersectionResultArray results); if (result == SetComparisonResult.Overlap) { sectCount += 1; fenses.Add(line); } } if (sectCount == 2) { XYZ projecting = fenses[0].Evaluate(0.5, true); XYZ projected = fenses[1].Project(projecting).XYZPoint; if (fenses[0].Length > fenses[1].Length) { projecting = fenses[1].Evaluate(0.5, true); projected = fenses[0].Project(projecting).XYZPoint; } Line doorAxis = Line.CreateBound(projecting, projected); doorAxes.Add(doorAxis); //doorAxes.Add(doorBlock[i]); } } //Debug.Print("Curves adjoning the box: " + doorFrame.Count.ToString()); } Debug.Print("We got {0} door axes. ", doorAxes.Count); // Collect window blocks var windowClusters = Algorithm.ClusterByIntersect(windowCrvs); List <List <Curve> > windowBlocks = new List <List <Curve> > { }; foreach (List <Curve> cluster in windowClusters) { if (null != Algorithm.CreateBoundingBox2D(cluster)) { windowBlocks.Add(Algorithm.CreateBoundingBox2D(cluster)); } } //Debug.Print("{0} clustered window blocks in total", windowBlocks.Count); List <Curve> windowAxes = new List <Curve> { }; foreach (List <Curve> windowBlock in windowBlocks) { Line axis1 = Line.CreateBound((windowBlock[0].GetEndPoint(0) + windowBlock[0].GetEndPoint(1)).Divide(2), (windowBlock[2].GetEndPoint(0) + windowBlock[2].GetEndPoint(1)).Divide(2)); Line axis2 = Line.CreateBound((windowBlock[1].GetEndPoint(0) + windowBlock[1].GetEndPoint(1)).Divide(2), (windowBlock[3].GetEndPoint(0) + windowBlock[3].GetEndPoint(1)).Divide(2)); if (axis1.Length > axis2.Length) { windowAxes.Add(axis1); } else { windowAxes.Add(axis2); } } Debug.Print("We got {0} window axes. ", windowAxes.Count); if (IsSilent) { // Main transaction // Plot axis of doors/windows and create the instance using (Transaction tx = new Transaction(doc, "Generate sub-surfaces & marks")) { FailureHandlingOptions options = tx.GetFailureHandlingOptions(); options.SetFailuresPreprocessor(new Util.FailureSwallower(false, false)); // Switch this for the failure list test // Util.FailureCollector fc = new Util.FailureCollector(); // options.SetFailuresPreprocessor(fc); tx.SetFailureHandlingOptions(options); tx.Start(); /* * Plane Geomplane = Plane.CreateByNormalAndOrigin(XYZ.BasisZ, XYZ.Zero); * SketchPlane sketch = SketchPlane.Create(doc, Geomplane); * * // Create door & window blocks * * foreach (List<Curve> doorBlock in doorBlocks) * { * //Debug.Print("Creating new bounding box"); * foreach (Curve edge in doorBlock) * { * ModelCurve modelline = doc.Create.NewModelCurve(edge, sketch) as ModelCurve; * } * } * foreach (List<Curve> windowBlock in windowBlocks) * { * //Debug.Print("Creating new bounding box"); * foreach (Curve edge in windowBlock) * { * ModelCurve modelline = doc.Create.NewModelCurve(edge, sketch) as ModelCurve; * } * } */ // Create door axis & instance foreach (Curve doorAxis in doorAxes) { /* * DetailLine axis = doc.Create.NewDetailCurve(view, doorAxis) as DetailLine; * GraphicsStyle gs = axis.LineStyle as GraphicsStyle; * gs.GraphicsStyleCategory.LineColor = new Color(202, 51, 82); * gs.GraphicsStyleCategory.SetLineWeight(7, gs.GraphicsStyleType); */ Wall hostWall = Wall.Create(doc, doorAxis, level.Id, true); double width = Math.Round(Misc.FootToMm(doorAxis.Length), 0); double height = 2000; XYZ basePt = (doorAxis.GetEndPoint(0) + doorAxis.GetEndPoint(1)).Divide(2); XYZ insertPt = basePt + XYZ.BasisZ * level.Elevation; // Absolute height double span = Double.PositiveInfinity; int labelId = -1; foreach (Util.TeighaText.CADTextModel text in labels) { double distance = basePt.DistanceTo(text.Location); if (distance < span) { span = distance; labelId = labels.IndexOf(text); } } if (labelId > -1) { width = Util.TeighaText.DecodeLabel(labels[labelId].Text, width, height).Item1; height = Util.TeighaText.DecodeLabel(labels[labelId].Text, width, height).Item2; //Debug.Print("Raw window label: {0}", labels[labelId].Text); } Debug.Print("Create new door with dimension {0}x{1}", width.ToString(), height.ToString()); FamilySymbol fs = NewOpeningType(doc, nameDoor, width, height, "Door"); if (null == fs) { continue; } if (!fs.IsActive) { fs.Activate(); } FamilyInstance fi = doc.Create.NewFamilyInstance(insertPt, fs, hostWall, level, Autodesk.Revit.DB.Structure.StructuralType.NonStructural); } // Create window axis & instance foreach (Curve windowAxis in windowAxes) { /* * DetailLine axis = doc.Create.NewDetailCurve(view, windowAxis) as DetailLine; * GraphicsStyle gs = axis.LineStyle as GraphicsStyle; * gs.GraphicsStyleCategory.LineColor = new Color(202, 51, 82); * gs.GraphicsStyleCategory.SetLineWeight(7, gs.GraphicsStyleType); */ Wall hostWall = Wall.Create(doc, windowAxis, level.Id, true); double width = Math.Round(Misc.FootToMm(windowAxis.Length), 0); double height = 2500; XYZ basePt = (windowAxis.GetEndPoint(0) + windowAxis.GetEndPoint(1)).Divide(2); // On world plane XYZ insertPt = basePt + XYZ.BasisZ * (Misc.MmToFoot(Properties.Settings.Default.sillHeight) + level.Elevation); // Absolute height double span = Misc.MmToFoot(2000); int labelId = -1; foreach (Util.TeighaText.CADTextModel text in labels) { double distance = basePt.DistanceTo(text.Location); //Debug.Print("Compare the two pts: " + Util.PrintXYZ(basePt) + " " + Util.PrintXYZ(text.Location)); if (distance < span) { span = distance; labelId = labels.IndexOf(text); } } if (labelId > -1) { width = Util.TeighaText.DecodeLabel(labels[labelId].Text, width, height).Item1; height = Util.TeighaText.DecodeLabel(labels[labelId].Text, width, height).Item2; if (height + Properties.Settings.Default.sillHeight > Properties.Settings.Default.floorHeight) { height = Properties.Settings.Default.floorHeight - Properties.Settings.Default.sillHeight; } //Debug.Print("Raw window label: {0}", labels[labelId].Text); } Debug.Print("Create new window with dimension {0}x{1}", width.ToString(), height.ToString()); FamilySymbol fs = NewOpeningType(doc, nameWindow, width, height, "Window"); if (null == fs) { continue; } if (!fs.IsActive) { fs.Activate(); } FamilyInstance fi = doc.Create.NewFamilyInstance(insertPt, fs, hostWall, level, Autodesk.Revit.DB.Structure.StructuralType.NonStructural); } tx.Commit(); } // Switch this for the failure list test // fc.ShowDialogue(); } ///////////////////////////// // UNDER PRESENTATION MODE // else { string caption = "Create openings"; string task = "Creating doors..."; Views.ProgressBar pb1 = new Views.ProgressBar(caption, task, doorAxes.Count); foreach (Curve doorAxis in doorAxes) { using (Transaction tx = new Transaction(doc, "Generate doors & adherences")) { //FailureHandlingOptions failOpt = tx.GetFailureHandlingOptions(); //failOpt.SetFailuresPreprocessor(new Util.WarningSwallower(false, false)); //tx.SetFailureHandlingOptions(failOpt);] tx.Start(); Wall hostWall = Wall.Create(doc, doorAxis, level.Id, true); double width = Math.Round(Misc.FootToMm(doorAxis.Length), 0); double height = 2000; XYZ basePt = (doorAxis.GetEndPoint(0) + doorAxis.GetEndPoint(1)).Divide(2); XYZ insertPt = basePt + XYZ.BasisZ * level.Elevation; // Absolute height double span = Double.PositiveInfinity; int labelId = -1; foreach (Util.TeighaText.CADTextModel text in labels) { double distance = basePt.DistanceTo(text.Location); if (distance < span) { span = distance; labelId = labels.IndexOf(text); } } if (labelId > -1) { width = Util.TeighaText.DecodeLabel(labels[labelId].Text, width, height).Item1; height = Util.TeighaText.DecodeLabel(labels[labelId].Text, width, height).Item2; //Debug.Print("Raw window label: {0}", labels[labelId].Text); } Debug.Print("Create new door with dimension {0}x{1}", width.ToString(), height.ToString()); FamilySymbol fs = NewOpeningType(doc, nameDoor, width, height, "Door"); if (null == fs) { continue; } if (!fs.IsActive) { fs.Activate(); } FamilyInstance fi = doc.Create.NewFamilyInstance(insertPt, fs, hostWall, level, Autodesk.Revit.DB.Structure.StructuralType.NonStructural); tx.Commit(); } pb1.Increment(); if (pb1.ProcessCancelled) { break; } } pb1.Close(); task = "Creating windows..."; Views.ProgressBar pb2 = new Views.ProgressBar(caption, task, windowAxes.Count); // Create window axis & instance foreach (Curve windowAxis in windowAxes) { using (Transaction tx = new Transaction(doc, "Generate windows & adherences")) { tx.Start(); Wall hostWall = Wall.Create(doc, windowAxis, level.Id, true); double width = Math.Round(Misc.FootToMm(windowAxis.Length), 0); double height = 2500; XYZ basePt = (windowAxis.GetEndPoint(0) + windowAxis.GetEndPoint(1)).Divide(2); // On world plane XYZ insertPt = basePt + XYZ.BasisZ * (Misc.MmToFoot(Properties.Settings.Default.sillHeight) + level.Elevation); // Absolute height double span = Misc.MmToFoot(2000); int labelId = -1; foreach (Util.TeighaText.CADTextModel text in labels) { double distance = basePt.DistanceTo(text.Location); //Debug.Print("Compare the two pts: " + Util.PrintXYZ(basePt) + " " + Util.PrintXYZ(text.Location)); if (distance < span) { span = distance; labelId = labels.IndexOf(text); } } if (labelId > -1) { width = Util.TeighaText.DecodeLabel(labels[labelId].Text, width, height).Item1; height = Util.TeighaText.DecodeLabel(labels[labelId].Text, width, height).Item2; if (height + Properties.Settings.Default.sillHeight > Properties.Settings.Default.floorHeight) { height = Properties.Settings.Default.floorHeight - Properties.Settings.Default.sillHeight; } //Debug.Print("Raw window label: {0}", labels[labelId].Text); } Debug.Print("Create new window with dimension {0}x{1}", width.ToString(), height.ToString()); FamilySymbol fs = NewOpeningType(doc, nameWindow, width, height, "Window"); if (null == fs) { continue; } if (!fs.IsActive) { fs.Activate(); } FamilyInstance fi = doc.Create.NewFamilyInstance(insertPt, fs, hostWall, level, Autodesk.Revit.DB.Structure.StructuralType.NonStructural); tx.Commit(); } pb2.Increment(); if (pb2.ProcessCancelled) { break; } } pb2.JobCompleted(); } }
public static void Execute(UIApplication uiapp, List <Curve> wallCrvs, Level level, bool IsSilent) { UIDocument uidoc = uiapp.ActiveUIDocument; Application app = uiapp.Application; Document doc = uidoc.Document; // Bundle double lines and generate their axes List <Curve> axes = new List <Curve>(); double bias = Misc.MmToFoot(20); var doubleLines = Misc.CrvsToLines(wallCrvs); for (int i = 0; i < doubleLines.Count; i++) { for (int j = 0; j < doubleLines.Count - i; j++) { if (Algorithm.IsParallel(doubleLines[i], doubleLines[i + j]) && !Algorithm.IsIntersected(doubleLines[i], doubleLines[i + j])) { // Imperical Units within Revit API if (Algorithm.LineSpacing(doubleLines[i], doubleLines[i + j]) < Misc.MmToFoot(200) + bias && Algorithm.LineSpacing(doubleLines[i], doubleLines[i + j]) > Misc.MmToFoot(200) - bias && Algorithm.IsShadowing(doubleLines[i], doubleLines[i + j])) { if (Algorithm.GenerateAxis(doubleLines[i], doubleLines[i + j]) != null) { axes.Add(Algorithm.GenerateAxis(doubleLines[i], doubleLines[i + j])); } Debug.Print(doubleLines[i].Length.ToString() + " | " + doubleLines[i + j].Length.ToString()); } } } } // Axis merge / List <Curve> mergedAxes = Algorithm.MergeAxes(axes); Debug.Print("The merged axes number " + mergedAxes.Count.ToString()); string task = "Creating Walls..."; string caption = "Extrude Walls"; int n = mergedAxes.Count; /*using (Transaction tx = new Transaction(doc, "Generate walls")) * { * tx.Start(); * * // Wall generation * foreach (Curve axis in mergedAxes) * { * Wall.Create(doc, axis, level.Id, true); * } * * tx.Commit(); * }*/ if (IsSilent == true) { using (Transaction tx = new Transaction(doc, "Generate a wall")) { FailureHandlingOptions options = tx.GetFailureHandlingOptions(); options.SetFailuresPreprocessor(new Util.FailureSwallower(false, false)); tx.SetFailureHandlingOptions(options); tx.Start(); foreach (Curve axis in mergedAxes) { Wall.Create(doc, axis, level.Id, true); } tx.Commit(); } } else { Views.ProgressBar pb = new Views.ProgressBar(caption, task, n); foreach (Curve axis in mergedAxes) { using (Transaction tx = new Transaction(doc, "Generate a wall")) { tx.Start(); Wall.Create(doc, axis, level.Id, true); tx.Commit(); } pb.Increment(); if (pb.ProcessCancelled) { break; } } pb.JobCompleted(); } }
public Result Execute(ExternalCommandData commandData, ref string message, ElementSet elements) { AppDomain currentDomain = AppDomain.CurrentDomain; currentDomain.AssemblyResolve += new ResolveEventHandler(Misc.LoadFromSameFolder); UIApplication uiapp = commandData.Application; UIDocument uidoc = uiapp.ActiveUIDocument; Application app = uiapp.Application; Document doc = uidoc.Document; View active_view = doc.ActiveView; double tolerance = app.ShortCurveTolerance; /////////////////////// // Pick Import Instance ImportInstance import = null; try { Reference r = uidoc.Selection.PickObject(ObjectType.Element, new Util.ElementsOfClassSelectionFilter <ImportInstance>()); import = doc.GetElement(r) as ImportInstance; } catch { return(Result.Cancelled); } if (import == null) { System.Windows.MessageBox.Show("CAD not found", "Tips"); return(Result.Cancelled); } // Initiate the progress bar Views.ProgressBar pb = new Views.ProgressBar("Modeling entire building", "Initiation...", 100); if (pb.ProcessCancelled) { return(Result.Cancelled); } ////////////////////////////////// // Check if the families are ready pb.CustomizeStatus("Checking families...", 2); if (pb.ProcessCancelled) { return(Result.Cancelled); } // Consider to add more customized families (in the Setting Panel) if (Properties.Settings.Default.name_door == null || Properties.Settings.Default.name_window == null || Properties.Settings.Default.name_columnRect == null || Properties.Settings.Default.name_columnRound == null) { System.Windows.MessageBox.Show("Please select the column/door/window type in settings", "Tips"); return(Result.Cancelled); } //if (!File.Exists(Properties.Settings.Default.url_door) && File.Exists(Properties.Settings.Default.url_window) // && File.Exists(Properties.Settings.Default.url_column)) //{ // System.Windows.MessageBox.Show("Please check the family path is solid", "Tips"); // return Result.Cancelled; //} //Family fColumn, fDoor, fWindow = null; //using (Transaction tx = new Transaction(doc, "Load necessary families")) //{ // tx.Start(); // if (!doc.LoadFamily(Properties.Settings.Default.url_column, out fColumn)) // { // System.Windows.MessageBox.Show("Please check the column family path is solid", "Tips"); // return Result.Cancelled; // } // if (!doc.LoadFamily(Properties.Settings.Default.url_door, out fDoor) || // !doc.LoadFamily(Properties.Settings.Default.url_window, out fWindow)) // { // System.Windows.MessageBox.Show("Please check the door/window family path is solid", "Tips"); // return Result.Cancelled; // } // tx.Commit(); //} // Prepare a family for ViewPlan creation // It may be a coincidence that the 1st ViewFamilyType is for the FloorPlan // Uplift needed here (doomed if it happends to be a CeilingPlan) ViewFamilyType viewType = new FilteredElementCollector(doc) .OfClass(typeof(ViewFamilyType)).First() as ViewFamilyType; RoofType roofType = new FilteredElementCollector(doc) .OfClass(typeof(RoofType)).FirstOrDefault <Element>() as RoofType; FloorType floorType = new FilteredElementCollector(doc) .OfClass(typeof(FloorType)).FirstOrDefault <Element>() as FloorType; //////////////////// // DATA PREPARATIONS pb.CustomizeStatus("Processing geometries...", 3); if (pb.ProcessCancelled) { return(Result.Cancelled); } // Prepare frames and levels // Cluster all geometry elements and texts into datatrees // Two procedures are intertwined List <GeometryObject> dwg_frames = Util.TeighaGeometry.ExtractElement(uidoc, import, Properties.Settings.Default.layerFrame, "PolyLine"); // framework is polyline by default List <GeometryObject> dwg_geos = Util.TeighaGeometry.ExtractElement(uidoc, import); // Terminate if no geometry has been found if (dwg_geos == null) { System.Windows.MessageBox.Show("A drawing frame is mandantory", "Tips"); return(Result.Failed); } List <PolyLine> closedPolys = new List <PolyLine>(); List <PolyLine> parentPolys = new List <PolyLine>(); Debug.Print("Number of geos acting as the framework is " + dwg_frames.Count().ToString()); if (dwg_frames.Count > 0) { foreach (var obj in dwg_frames) { PolyLine poly = obj as PolyLine; // Draw shattered lines in case the object is a PolyLine if (null != poly) { var vertices = poly.GetCoordinates(); if (vertices[0].IsAlmostEqualTo(vertices.Last())) { closedPolys.Add(poly); } } } for (int i = 0; i < closedPolys.Count(); i++) { int judgement = 0; int counter = 0; for (int j = 0; j < closedPolys.Count(); j++) { if (i != j) { if (!RegionDetect.PolyInPoly(closedPolys[i], RegionDetect.PolyLineToCurveArray(closedPolys[j], tolerance))) { //Debug.Print("Poly inside poly detected"); judgement += 1; } counter += 1; } } if (judgement == counter) { parentPolys.Add(closedPolys[i]); } } } else { Debug.Print("There is no returning of geometries"); } Debug.Print("Got closedPolys: " + closedPolys.Count().ToString()); Debug.Print("Got parentPolys: " + parentPolys.Count().ToString()); string path = Util.TeighaText.GetCADPath(uidoc, import); Debug.Print("The path of linked CAD file is: " + path); List <Util.TeighaText.CADTextModel> texts = Util.TeighaText.GetCADText(path); int level; int levelCounter = 0; double floorHeight = Misc.MmToFoot(Properties.Settings.Default.floorHeight); Dictionary <int, PolyLine> frameDict = new Dictionary <int, PolyLine>(); // cache drawing borders Dictionary <int, XYZ> transDict = new Dictionary <int, XYZ>(); // cache transform vector from the left-bottom corner of the drawing border to the Origin Dictionary <int, List <GeometryObject> > geoDict = new Dictionary <int, List <GeometryObject> >(); // cache geometries of each floorplan Dictionary <int, List <Util.TeighaText.CADTextModel> > textDict = new Dictionary <int, List <Util.TeighaText.CADTextModel> >(); // cache text info of each floorplan if (texts.Count > 0) { foreach (var textmodel in texts) { level = Misc.GetLevel(textmodel.Text, "平面图"); Debug.Print("Got target label " + textmodel.Text); if (level != -1) { foreach (PolyLine frame in parentPolys) { if (RegionDetect.PointInPoly(RegionDetect.PolyLineToCurveArray(frame, tolerance), textmodel.Location)) { XYZ basePt = Algorithm.BubbleSort(frame.GetCoordinates().ToList())[0]; XYZ transVec = XYZ.Zero - basePt; Debug.Print("Add level " + level.ToString() + " with transaction (" + transVec.X.ToString() + ", " + transVec.Y.ToString() + ", " + transVec.Z.ToString() + ")"); if (!frameDict.Values.ToList().Contains(frame)) { frameDict.Add(level, frame); transDict.Add(level, transVec); levelCounter += 1; } } } } } // Too complicated using 2 iterations... uplift needed for (int i = 1; i <= levelCounter; i++) { textDict.Add(i, new List <Util.TeighaText.CADTextModel>()); geoDict.Add(i, new List <GeometryObject>()); CurveArray tempPolyArray = RegionDetect.PolyLineToCurveArray(frameDict[i], tolerance); foreach (var textmodel in texts) { if (RegionDetect.PointInPoly(tempPolyArray, textmodel.Location)) { textDict[i].Add(textmodel); } } foreach (GeometryObject go in dwg_geos) { XYZ centPt = XYZ.Zero; if (go is Line) { //get the revit model coordinates. Line go_line = go as Line; centPt = (go_line.GetEndPoint(0) + go_line.GetEndPoint(1)).Divide(2); } else if (go is Arc) { Arc go_arc = go as Arc; centPt = go_arc.Center; } else if (go is PolyLine) { PolyLine go_poly = go as PolyLine; centPt = go_poly.GetCoordinate(0); } // Assignment if (RegionDetect.PointInPoly(tempPolyArray, centPt) && centPt != XYZ.Zero) { geoDict[i].Add(go); } } } } Debug.Print("All levels: " + levelCounter.ToString()); Debug.Print("frameDict: " + frameDict.Count().ToString()); Debug.Print("transDict: " + transDict.Count().ToString()); for (int i = 1; i <= levelCounter; i++) { Debug.Print("geoDict-{0}: {1}", i, geoDict[i].Count().ToString()); } Debug.Print("textDict: " + textDict.Count().ToString() + " " + textDict[1].Count().ToString()); //////////////////// // MAIN TRANSACTIONS // Prepare a family and configurations for TextNote (Put it inside transactions) /* * TextNoteType tnt = new FilteredElementCollector(doc) * .OfClass(typeof(TextNoteType)).First() as TextNoteType; * TextNoteOptions options = new TextNoteOptions(); * options.HorizontalAlignment = HorizontalTextAlignment.Center; * options.TypeId = doc.GetDefaultElementTypeId(ElementTypeGroup.TextNoteType); * BuiltInParameter paraIndex = BuiltInParameter.TEXT_SIZE; * Parameter textSize = tnt.get_Parameter(paraIndex); * textSize.Set(0.3); // in feet * * XYZ centPt = RegionDetect.PolyCentPt(frameDict[i]); * TextNoteOptions opts = new TextNoteOptions(tnt.Id); * * // The note may only show in the current view * // no matter we still need it anyway * TextNote txNote = TextNote.Create(doc, active_view.Id, centPt, floorView.Name, options); * txNote.ChangeTypeId(tnt.Id); * * // Draw model lines of frames as notation * Plane Geomplane = Plane.CreateByNormalAndOrigin(XYZ.BasisZ, XYZ.Zero + transDict[i] + XYZ.BasisZ * (i - 1) * floorHeight); * SketchPlane sketch = SketchPlane.Create(doc, Geomplane); * CurveArray shatters = RegionDetect.PolyLineToCurveArray(frameDict[i], tolerance); * Transform alignModelLine = Transform.CreateTranslation(transDict[i] + XYZ.BasisZ * (i - 1) * floorHeight); * foreach (Curve shatter in shatters) * { * Curve alignedCrv = shatter.CreateTransformed(alignModelLine); * ModelCurve modelline = doc.Create.NewModelCurve(alignedCrv, sketch) as ModelCurve; * } */ // ITERATION FLAG for (int i = 1; i <= levelCounter; i++) { pb.CustomizeStatus("On Floor " + i.ToString() + "... with lines", 5); if (pb.ProcessCancelled) { return(Result.Cancelled); } TransactionGroup tg = new TransactionGroup(doc, "Generate on floor-" + i.ToString()); { try { tg.Start(); // MILESTONE // Align the labels to the origin Transform alignment = Transform.CreateTranslation(transDict[i]); foreach (Util.TeighaText.CADTextModel label in textDict[i]) { label.Location = label.Location + transDict[i]; } // MILESTONE // Sort out lines List <Curve> wallCrvs = new List <Curve>(); List <Curve> columnCrvs = new List <Curve>(); List <Curve> doorCrvs = new List <Curve>(); List <Curve> windowCrvs = new List <Curve>(); foreach (GeometryObject go in geoDict[i]) { var gStyle = doc.GetElement(go.GraphicsStyleId) as GraphicsStyle; if (gStyle.GraphicsStyleCategory.Name == Properties.Settings.Default.layerWall) { if (go.GetType().Name == "Line") { Curve wallLine = go as Curve; wallCrvs.Add(wallLine.CreateTransformed(alignment) as Line); } if (go.GetType().Name == "PolyLine") { CurveArray wallPolyLine_shattered = RegionDetect.PolyLineToCurveArray(go as PolyLine, tolerance); foreach (Curve crv in wallPolyLine_shattered) { wallCrvs.Add(crv.CreateTransformed(alignment) as Line); } } } if (gStyle.GraphicsStyleCategory.Name == Properties.Settings.Default.layerColumn) { if (go.GetType().Name == "Line") { Curve columnLine = go as Curve; columnCrvs.Add(columnLine.CreateTransformed(alignment)); } if (go.GetType().Name == "PolyLine") { CurveArray columnPolyLine_shattered = RegionDetect.PolyLineToCurveArray(go as PolyLine, tolerance); foreach (Curve crv in columnPolyLine_shattered) { columnCrvs.Add(crv.CreateTransformed(alignment)); } } } if (gStyle.GraphicsStyleCategory.Name == Properties.Settings.Default.layerDoor) { Curve doorCrv = go as Curve; PolyLine poly = go as PolyLine; if (null != doorCrv) { doorCrvs.Add(doorCrv.CreateTransformed(alignment)); } if (null != poly) { CurveArray columnPolyLine_shattered = RegionDetect.PolyLineToCurveArray(poly, tolerance); foreach (Curve crv in columnPolyLine_shattered) { doorCrvs.Add(crv.CreateTransformed(alignment) as Line); } } } if (gStyle.GraphicsStyleCategory.Name == Properties.Settings.Default.layerWindow) { Curve windowCrv = go as Curve; PolyLine poly = go as PolyLine; if (null != windowCrv) { windowCrvs.Add(windowCrv.CreateTransformed(alignment)); } if (null != poly) { CurveArray columnPolyLine_shattered = RegionDetect.PolyLineToCurveArray(poly, tolerance); foreach (Curve crv in columnPolyLine_shattered) { windowCrvs.Add(crv.CreateTransformed(alignment) as Line); } } } } // MILESTONE // Create additional levels (ignore what's present) // Consider to use sub-transaction here using (var t_level = new Transaction(doc)) { t_level.Start("Create levels"); Level floor = Level.Create(doc, (i - 1) * floorHeight); ViewPlan floorView = ViewPlan.Create(doc, viewType.Id, floor.Id); floorView.Name = "F-" + i.ToString(); t_level.Commit(); } // Grab the current building level FilteredElementCollector colLevels = new FilteredElementCollector(doc) .WhereElementIsNotElementType() .OfCategory(BuiltInCategory.INVALID) .OfClass(typeof(Level)); Level currentLevel = colLevels.LastOrDefault() as Level; // The newly created level will append to the list, // but this is not a safe choice // Sub-transactions are packed within these functions. // The family names should be defined by the user in WPF // MILESTONE pb.CustomizeStatus("On Floor " + i.ToString() + "... with Walls", 90 / levelCounter / 4); if (pb.ProcessCancelled) { return(Result.Cancelled); } CreateWall.Execute(uiapp, wallCrvs, currentLevel, true); // MILESTONE pb.CustomizeStatus("On Floor " + i.ToString() + "... with Columns", 90 / levelCounter / 4); if (pb.ProcessCancelled) { return(Result.Cancelled); } CreateColumn.Execute(app, doc, columnCrvs, Properties.Settings.Default.name_columnRect, Properties.Settings.Default.name_columnRound, currentLevel, true); // MILESTONE pb.CustomizeStatus("On Floor " + i.ToString() + "... with Openings", 90 / levelCounter / 4); if (pb.ProcessCancelled) { return(Result.Cancelled); } CreateOpening.Execute(doc, doorCrvs, windowCrvs, wallCrvs, textDict[i], Properties.Settings.Default.name_door, Properties.Settings.Default.name_window, currentLevel, true); // Create floor // MILESTONE var footprint = CreateRegion.Execute(doc, wallCrvs, columnCrvs, windowCrvs, doorCrvs); using (var t_floor = new Transaction(doc)) { t_floor.Start("Generate Floor"); Floor newFloor = doc.Create.NewFloor(footprint, floorType, currentLevel, false, XYZ.BasisZ); newFloor.get_Parameter(BuiltInParameter.FLOOR_HEIGHTABOVELEVEL_PARAM).Set(0); t_floor.Commit(); } // Generate rooms after the topology is established pb.CustomizeStatus("On Floor " + i.ToString() + "... with Rooms", 90 / levelCounter / 4); if (pb.ProcessCancelled) { return(Result.Cancelled); } // MILESTONE using (var t_space = new Transaction(doc)) { t_space.Start("Create rooms"); doc.Regenerate(); PlanTopology planTopology = doc.get_PlanTopology(currentLevel); if (doc.ActiveView.ViewType == ViewType.FloorPlan) { foreach (PlanCircuit circuit in planTopology.Circuits) { if (null != circuit && !circuit.IsRoomLocated) { Room room = doc.Create.NewRoom(null, circuit); room.LimitOffset = floorHeight; room.BaseOffset = 0; string roomName = ""; foreach (Util.TeighaText.CADTextModel label in textDict[i]) { if (label.Layer == Properties.Settings.Default.layerSpace) { if (room.IsPointInRoom(label.Location + XYZ.BasisZ * (i - 1) * floorHeight)) { roomName += label.Text; } } } if (roomName != "") { room.Name = roomName; } } } } t_space.Commit(); } // Create roof when iterating to the last level // MILESTONE if (i == levelCounter) { using (var t_roof = new Transaction(doc)) { t_roof.Start("Create roof"); Level roofLevel = Level.Create(doc, i * floorHeight); ViewPlan floorView = ViewPlan.Create(doc, viewType.Id, roofLevel.Id); floorView.Name = "Roof"; ModelCurveArray footPrintToModelCurveMapping = new ModelCurveArray(); FootPrintRoof footprintRoof = doc.Create.NewFootPrintRoof(footprint, roofLevel, roofType, out footPrintToModelCurveMapping); //ModelCurveArrayIterator iterator = footPrintToModelCurveMapping.ForwardIterator(); /* * iterator.Reset(); * while (iterator.MoveNext()) * { * ModelCurve modelCurve = iterator.Current as ModelCurve; * footprintRoof.set_DefinesSlope(modelCurve, true); * footprintRoof.set_SlopeAngle(modelCurve, 0.5); * } */ t_roof.Commit(); } } tg.Assimilate(); } catch { System.Windows.MessageBox.Show("Error", "Tips"); tg.RollBack(); } } pb.JobCompleted(); } return(Result.Succeeded); }